"use strict";
/* eslint-disable react-hooks/rules-of-hooks */
/// <reference types="react/experimental" />
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSourceModern = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const source_1 = require("../source");
const { unstable_createMutableSource: createMutableSource, unstable_useMutableSource: useMutableSource, } = react_1.default;
const MissingToken = Symbol();
const subscribe = ([, subscribe], cb) => subscribe(cb);
let mutableSources;
const useSourceModern = (maybeSource, options = {}) => {
    const hasDefaultValue = 'defaultValue' in options;
    const { defaultValue, startTransition } = options;
    const [core, select] = maybeSource || source_1.nullSource;
    if (!mutableSources) {
        mutableSources = new WeakMap([
            [source_1.nullSource[0], createMutableSource(source_1.nullSource[0], source_1.nullSource[0][0])],
        ]);
    }
    const getSnapshot = react_1.useCallback(([getVersion]) => hasDefaultValue && !source_1.hasSnapshot([[getVersion], select])
        ? MissingToken
        : select(getVersion()), [hasDefaultValue, select]);
    const subscribeWithTransition = react_1.useMemo(() => startTransition
        ? ([, subscribe], callback) => subscribe(() => {
            startTransition(callback);
        })
        : subscribe, [startTransition]);
    let mutableSource = mutableSources.get(core);
    if (!mutableSource) {
        const getVersion = () => source_1.hasSnapshot([core, source_1.identitySelector]) ? core[0]() : MissingToken;
        mutableSource = createMutableSource(core, getVersion);
        mutableSources.set(core, mutableSource);
    }
    const value = useMutableSource(mutableSource, getSnapshot, subscribeWithTransition);
    return value === MissingToken || maybeSource === null ? defaultValue : value;
};
exports.useSourceModern = useSourceModern;
