"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.map = void 0;
const fuse_1 = require("./fuse");
/**
 * Map differs from select in that the map function will only be called
 * upon changes to the original source, and thus it is safe to create new
 * objects in the map function.
 */
function map(source, mapFn) {
    return fuse_1.fuse((use) => mapFn(use(source)));
}
exports.map = map;
