/* eslint-disable react-hooks/rules-of-hooks */
/// <reference types="react/experimental" />
import React, { useCallback, useMemo } from 'react';
import { hasSnapshot, identitySelector, nullSource, } from '../source';
const { unstable_createMutableSource: createMutableSource, unstable_useMutableSource: useMutableSource, } = React;
const MissingToken = Symbol();
const subscribe = ([, subscribe], cb) => subscribe(cb);
let mutableSources;
export const useSourceModern = (maybeSource, options = {}) => {
    const hasDefaultValue = 'defaultValue' in options;
    const { defaultValue, startTransition } = options;
    const [core, select] = maybeSource || nullSource;
    if (!mutableSources) {
        mutableSources = new WeakMap([
            [nullSource[0], createMutableSource(nullSource[0], nullSource[0][0])],
        ]);
    }
    const getSnapshot = useCallback(([getVersion]) => hasDefaultValue && !hasSnapshot([[getVersion], select])
        ? MissingToken
        : select(getVersion()), [hasDefaultValue, select]);
    const subscribeWithTransition = useMemo(() => startTransition
        ? ([, subscribe], callback) => subscribe(() => {
            startTransition(callback);
        })
        : subscribe, [startTransition]);
    let mutableSource = mutableSources.get(core);
    if (!mutableSource) {
        const getVersion = () => hasSnapshot([core, identitySelector]) ? core[0]() : MissingToken;
        mutableSource = createMutableSource(core, getVersion);
        mutableSources.set(core, mutableSource);
    }
    const value = useMutableSource(mutableSource, getSnapshot, subscribeWithTransition);
    return value === MissingToken || maybeSource === null ? defaultValue : value;
};
