import { fuse } from './fuse';
const defaultMerge = (latestSnapshot) => latestSnapshot;
const MissingToken = Symbol();
export function mergeLatest(source, merge = defaultMerge) {
    let fallback = [];
    // This needs a fuse instead of select, as there's no guarantee that a
    // select will actually be called with every value.
    const [core, select] = fuse((use) => {
        const value = use(source, ...fallback);
        const valueOrFlag = use(source, MissingToken);
        fallback = [value];
        return merge(value, valueOrFlag === MissingToken);
    });
    return [core, select, source[2]];
}
