import { Source } from './source';
export declare const TEARDOWN_DELAY = 10;
export interface ObserveSubscribeFunction<T> {
    (next: (value: T) => void, error: (error: any) => void, complete: () => void, // noop
    clear: () => void): (() => void) | {
        unsubscribe(): void;
    };
}
export declare function observe<T>(observable: ObserveSubscribeFunction<T> | {
    subscribe: ObserveSubscribeFunction<T>;
}): Source<T>;
