import { identity, isPromiseLike, noop, pendingPromiseLike, } from 'retil-support';
export function act(source, callback) {
    return source[2](callback);
}
export function getSnapshot([[getVersion], select,]) {
    return select(getVersion());
}
export function getSnapshotPromise([[getVersion], select,]) {
    try {
        return Promise.resolve(select(getVersion()));
    }
    catch (errorOrPromise) {
        if (isPromiseLike(errorOrPromise)) {
            return Promise.resolve(errorOrPromise).then(() => select(getVersion()));
        }
        return Promise.reject(errorOrPromise);
    }
}
export function hasSnapshot([[getVersion]]) {
    try {
        getVersion();
    }
    catch (errorOrPromise) {
        if (isPromiseLike(errorOrPromise)) {
            return false;
        }
    }
    return true;
}
export function subscribe([[, subscribe]], onChange, onSeal) {
    return subscribe(onChange, onSeal);
}
const constantSubscribe = (_change, seal) => {
    if (seal) {
        seal();
    }
    return noop;
};
const constantAct = (cb) => Promise.resolve(cb());
export const identitySelector = (value) => value;
export const constant = (value) => [
    [() => value, constantSubscribe],
    identity,
    constantAct,
];
export const nullSource = [
    [() => null, constantSubscribe],
    identity,
    constantAct,
];
export const pendingSource = [
    [
        () => {
            throw pendingPromiseLike;
        },
        constantSubscribe,
    ],
    identity,
    constantAct,
];
